/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.email.entity;

@javax.persistence.NamedQueries(
 {



       @javax.persistence.NamedQuery(
     name="EMAIL_LAYOUT.UK",
     query="SELECT o FROM EmailLayout o WHERE "

                         + "o"
                +".bezeichnung"
              +" = ?1"

     ,
   hints = {
              @javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
             @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
   }


   )
   
     ,   @javax.persistence.NamedQuery(
     name="EMAIL_LAYOUT.AllOrderByBezeichnung",
     query="select o from EmailLayout o order by o.bezeichnung",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="EMAIL_LAYOUT.Bezeichnung",
     query="select o from EmailLayout o where o.bezeichnung=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="EMAIL_LAYOUT.CountAll",
     query="select count(o) from EmailLayout o",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="EMAIL_LAYOUT.CountVerwendungTyp",
     query="select count(o) from EmailLayout o where o.verwendungTyp=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="EMAIL_LAYOUT.VerwendungTyp",
     query="select o from EmailLayout o where o.verwendungTyp=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="EMAIL_LAYOUT.VerwendungTypWhereBezeichnungNot",
     query="update EmailLayout o set o.verwendungTyp=?2 where o.bezeichnung!=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "EMAIL_LAYOUT")
// @javax.persistence.IdClass(EmailLayoutPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class EmailLayout
implements EmailLayoutBase
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public EmailLayout() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public EmailLayout(EmailLayout original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "email_layout_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "EmailLayout")
    @javax.persistence.TableGenerator(name = "EmailLayout", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "EmailLayout", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient EmailLayoutPK pkCache;

  @Override
  public EmailLayoutPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new EmailLayoutPK(getId());
    }

    return pkCache;
  }

  public static <E extends EmailLayout> java.util.Map<EmailLayoutPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<EmailLayoutPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends EmailLayout> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedBezeichnung = false;
          hasChangedInhalt = false;
          hasChangedVerwendungTyp = false;
  


                
    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
      @javax.persistence.Column(name = "BEZEICHNUNG", nullable = EmailLayoutConstants.BEZEICHNUNG_NULLABLE, length=EmailLayoutConstants.BEZEICHNUNG_MAX_LENGTH)
        
  protected java.lang.String bezeichnung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBezeichnung = false;

  public boolean hasChangedBezeichnung(){
    return hasChangedBezeichnung;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertBezeichnung = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenBezeichnung;
  
  /**
   * 
   *
   * getter for EMAIL_LAYOUT.BEZEICHNUNG
   */
    @Override   public  java.lang.String getBezeichnung() {
        return bezeichnung;
      }

  /**
   * 
   *
   * setter for EMAIL_LAYOUT.BEZEICHNUNG
   *
   * @param bezeichnung
   */
  @Override   public void setBezeichnung( java.lang.String bezeichnung) {

       resetTkCache();
                  
                          java.lang.String bezeichnungInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(bezeichnung, EmailLayoutConstants.BEZEICHNUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.bezeichnung
      , bezeichnungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBezeichnung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("bezeichnung");
      }


             if (!isSeitLadenVeraendertBezeichnung) {
          isSeitLadenVeraendertBezeichnung = thisAttributChanged;
         if (isSeitLadenVeraendertBezeichnung){
           wertNachLadenBezeichnung=this.bezeichnung;
         }
       }
      

       this.bezeichnung = bezeichnungInternal;

         }

        
  @javax.persistence.Basic(fetch=javax.persistence.FetchType.LAZY)
  @javax.persistence.Lob
      @javax.persistence.Column(name = "INHALT", nullable = EmailLayoutConstants.INHALT_NULLABLE, length = Integer.MAX_VALUE)
    
  protected java.lang.String inhalt =  null;

  @javax.persistence.Transient
  protected boolean hasChangedInhalt = false;

  public boolean hasChangedInhalt(){
    return hasChangedInhalt;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertInhalt = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenInhalt;
  
  /**
   * 
   *
   * getter for EMAIL_LAYOUT.INHALT
   *
   * (LAZY LOADING)
   */
    @Override   public  java.lang.String getInhalt() {
        return inhalt;
      }

  /**
   * 
   *
   * setter for EMAIL_LAYOUT.INHALT
   *
   * @param inhalt
   */
  @Override   public void setInhalt( java.lang.String inhalt) {

       resetTkCache();
                  java.lang.String inhaltInternal = org.apache.commons.lang3.StringUtils.trimToNull(inhalt);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.inhalt
      , inhaltInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedInhalt |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("inhalt");
      }


             if (!isSeitLadenVeraendertInhalt) {
          isSeitLadenVeraendertInhalt = thisAttributChanged;
         if (isSeitLadenVeraendertInhalt){
           wertNachLadenInhalt=this.inhalt;
         }
       }
      

       this.inhalt = inhaltInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "VERWENDUNG_TYP", nullable = EmailLayoutConstants.VERWENDUNG_TYP_NULLABLE)
    
  protected de.ivu.elect.business.email.entity.EmailLayoutVerwendungType verwendungTyp =  de.ivu.elect.business.email.entity.EmailLayoutVerwendungType.NICHT_VORAUSGEWAEHLT;

  @javax.persistence.Transient
  protected boolean hasChangedVerwendungTyp = false;

  public boolean hasChangedVerwendungTyp(){
    return hasChangedVerwendungTyp;
  }
  
  /**
   * 
   *
   * getter for EMAIL_LAYOUT.VERWENDUNG_TYP
   */
    @Override   public  de.ivu.elect.business.email.entity.EmailLayoutVerwendungType getVerwendungTyp() {
        return verwendungTyp;
      }

  /**
   * 
   *
   * setter for EMAIL_LAYOUT.VERWENDUNG_TYP
   *
   * @param verwendungTyp
   */
  @Override   public void setVerwendungTyp( de.ivu.elect.business.email.entity.EmailLayoutVerwendungType verwendungTyp) {

       resetTkCache();
                  de.ivu.elect.business.email.entity.EmailLayoutVerwendungType verwendungTypInternal = verwendungTyp;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.verwendungTyp
      , verwendungTypInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedVerwendungTyp |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("verwendungTyp");
      }


      

       this.verwendungTyp = verwendungTypInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */

/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("EmailLayout:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(EmailLayout other){
                             other.bezeichnung = this.bezeichnung;
                                other.inhalt = this.inhalt;
                                other.verwendungTyp = this.verwendungTyp;
           
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(EmailLayout.class)){
        copyEntityAttributesUsingSetter((EmailLayout) other.castTo(EmailLayout.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von EmailLayout: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(EmailLayout other){
               other.setBezeichnung(this.bezeichnung);
                  other.setInhalt(this.inhalt);
                  other.setVerwendungTyp(this.verwendungTyp);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(EmailLayout other){
                       if (hasChangedBezeichnung) {
        other.setBezeichnung(this.bezeichnung);
      }
                             if (hasChangedInhalt) {
        other.setInhalt(this.inhalt);
      }
                             if (hasChangedVerwendungTyp) {
        other.setVerwendungTyp(this.verwendungTyp);
      }
             }





    @javax.persistence.Transient
    private transient EmailLayoutTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public EmailLayoutTK getEmailLayoutTK(){
    if (tkCache==null) {
    tkCache = new EmailLayoutTK(

getBezeichnung()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getEmailLayoutTK();
    }

  @Override
  public EmailLayoutUK getUk(){
    return getEmailLayoutUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return EmailLayout.class;
  }

public EmailLayoutUK getEmailLayoutUK(){

   return  new EmailLayoutUK(

getBezeichnung()


  );
}

  @javax.persistence.Transient
  private transient EmailLayoutProperties properties;

  public EmailLayoutProperties getProperties(){
    if (properties == null) {
      properties = new EmailLayoutProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public EmailLayoutProperties getEmailLayoutProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return EmailLayoutConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(EmailLayoutConstants.MESSAGE_KEY_BEZEICHNUNG_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(EmailLayoutConstants.MESSAGE_KEY_BEZEICHNUNG_EINZAHL);

        bezeichnung =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(EmailLayoutConstants.MESSAGE_KEY_INHALT_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(EmailLayoutConstants.MESSAGE_KEY_INHALT_EINZAHL);

        inhalt =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

                        }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertBezeichnung) {
      result.put(EmailLayoutConstants.MESSAGE_KEY_BEZEICHNUNG_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenBezeichnung , bezeichnung));
    }
                            if (isSeitLadenVeraendertInhalt) {
      result.put(EmailLayoutConstants.MESSAGE_KEY_INHALT_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.LOB
                , wertNachLadenInhalt , inhalt));
    }
                                    return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertBezeichnung = false;
      wertNachLadenBezeichnung = null;
                          isSeitLadenVeraendertInhalt = false;
      wertNachLadenInhalt = null;
                                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
            return result;
  }

        
            protected String getInitialDiscriminator() {
              return "EMAIL_LAYOUT";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "EmailLayout";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(bezeichnung, this, EmailLayoutConstants.MESSAGE_KEY_BEZEICHNUNG_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(EmailLayoutConstants.BEZEICHNUNG_MAX_LENGTH , 1 ,  bezeichnung, this, EmailLayoutConstants.MESSAGE_KEY_BEZEICHNUNG_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(inhalt, this, EmailLayoutConstants.MESSAGE_KEY_INHALT_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(EmailLayoutConstants.INHALT_MAX_LENGTH , 1 ,  inhalt, this, EmailLayoutConstants.MESSAGE_KEY_INHALT_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(verwendungTyp, this, EmailLayoutConstants.MESSAGE_KEY_VERWENDUNG_TYP_EINZAHL, validationResult);
                                                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
